'#Reference {BEE4BFEC-6683-3E67-9167-3C0CBC68F40A}#2.0#0#C:\Windows\Microsoft.NET\Framework\v2.0.50727\System.tlb#System
''Export files to TTX document for processing in a TM system
''Import translated TTX documents
' -------------------------------
' Version 1.0 Laszlo Kovacs 11 December 2010.
' -------------------------------
' Macro executes on:
' Projects		Active/opened translation bundles.
' Source lists	N/A
' Target lists	ALL
' ===============================


Option Explicit

Dim translst As PslTransList
Dim translsts As PslTransLists
Dim transstr As PslTransString
Dim i, j As Long
Dim myBundle As PslProject
Dim LockTranslated, LockForReview, SegmentUntranslated, ExportLocked As Boolean
Dim source_language, target_language As String

Const ForWriting = 2
Const ForReading = 1

    ' ===================================================================================
    ' Makes a text string XML-compliant by replacing the forbidden characters by entities
    Private Function XMLify(inputstring As String) As String
        inputstring = Replace(inputstring, "&", "&amp;")
        inputstring = Replace(inputstring, "<", "&lt;")
        inputstring = Replace(inputstring, ">", "&gt;")
        inputstring = Replace(inputstring, """", "&quot;")
        inputstring = Replace(inputstring, "'", "&apos;")
        XMLify = inputstring
    End Function

    ' =============================================================
    ' Restores the non-XML compliant raw text from an XMLified text
    Private Function deXMLify(inputstring As String) As String
        inputstring = Replace(inputstring, "&gt;", ">")
        inputstring = Replace(inputstring, "&quot;", """")
        inputstring = Replace(inputstring, "&apos;", "'")
        inputstring = Replace(inputstring, "&lt;", "<")
        inputstring = Replace(inputstring, "&amp;", "&")
        deXMLify = inputstring
    End Function

    ' =============================================================
    ' Applies tag protection to non-translatable parts of the text
	Private Function EscapeWhitespace(strText As String) As String

		strText = Replace(strText,"\","<ut Class=""entityreference"" DisplayText=""\"">\</ut>")
		strText = Replace(strText,Chr(10),"<ut Class=""entityreference"" DisplayText=""\n"">\n</ut>")
		strText = Replace(strText,Chr(13),"<ut Class=""entityreference"" DisplayText=""\r"">\r</ut>")
		strText = Replace(strText,Chr(9),"<ut Class=""entityreference"" DisplayText=""\t"">\t</ut>")
		strText = Replace(strText,"&amp;","<ut Class=""entityreference"" DisplayText=""&amp;"">&amp;</ut>")
		strText = Replace(strText,"_","<ut Class=""entityreference"" DisplayText=""_"">_</ut>")

		EscapeWhitespace=strText

	End Function

	Private Function UnEscapeWhitespace(strText As String) As String

		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""\n"">\n</ut>",Chr(10))
		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""\r"">\r</ut>",Chr(13))
		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""\t"">\t</ut>",Chr(9))
		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""\"">\</ut>","\")
		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""&amp;"">&amp;</ut>","&amp;")
		strText = Replace(strText,"<ut Class=""entityreference"" DisplayText=""_"">_</ut>","_")

		UnEscapeWhitespace=strText

	End Function

    ' ===================================
    ' Add leading zero to date components
    Private Function PadLeft2(IntNum As Integer) As String
        If Len(CStr(IntNum)) = 1 Then
           PadLeft2 = "0" & CStr(IntNum)
        Else
        	PadLeft2 = CStr(IntNum)
        End If
    End Function


Private Sub ExportTTXFile()
	Dim TTX_Header, TTX_Footer, TTX_Content, TTXOrigin, TTXMatchPercent As String
	Dim fso As Object
	Dim TTXfile As Object
	Set fso = CreateObject("Scripting.FileSystemObject")

	source_language =LCase(PSL.GetLangCode(myBundle.TransLists(1).SourceList.LangID,pslCodeTrados))


	PSL.Output ("Preparing TTX data...")

	'Open the file for writing

	Set TTXfile = fso.OpenTextFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".TTX" , ForWriting, True, True)

    TTX_Header = "<?xml version=""1.0"" encoding=""UTF-16"" standalone=""no"" ?><TRADOStag Version=""2.0""><FrontMatter><ToolSettings CreationDate=""" _
            &  Year(Now) & PadLeft2(Month(Now)) & PadLeft2(Day(Now)) & "T" & PadLeft2(Hour(Now)) & PadLeft2(Minute(Now)) & PadLeft2(Second(Now)) & "Z"" " & _
            "CreationTool=""SDL TRADOS TagEditor"" CreationToolVersion=""8.3.0.863""/><UserSettings DataType=""XML"" O-Encoding=""Unicode"" SettingsName=""Passolo"" SettingsPath=""" & _
            myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".ini"" SourceLanguage=""" & source_language & """ TargetLanguage=""" & target_language & """ TargetDefaultFont=""Arial"" SourceDocumentPath=""" & myBundle.Name & """ SettingsRelativePath="".\" & myBundle.Name & "_" & target_language & ".ini"" PlugInInfo=""""/>" & _
            "</FrontMatter><Body>"
    TTX_Footer = "</Body></TRADOStag>"
	TTX_Content = ""

	TTXfile.Writeline (TTX_Header)


	For i = 1 To myBundle.TransLists.Count
		Set translst = myBundle.TransLists(i)

		If LCase(PSL.GetLangCode(translst.Language.LangID,pslCodeTrados))=target_language Then
			source_language =LCase(PSL.GetLangCode(translst.SourceList.LangID,pslCodeTrados))

			PSL.Output ("Processing "+ CStr(i) + "/" + CStr(myBundle.TransLists.Count) + " - " + translst.Title)

			On Error GoTo nextStringList
			For j = 1 To translst.StringCount
				Set transstr = translst.String(j)

				If Not transstr.State(pslStateHidden) And Not transstr.State(pslStateInvisible) And Not transstr.Resource.State(pslStateHidden) And Not transstr.Resource.State(pslStateInvisible) Then


					If ExportLocked Or Not (transstr.State(pslStateLocked) Or transstr.State(pslStateReadOnly) Or transstr.Resource.State(pslStateLocked) Or transstr.Resource.State(pslStateReadOnly)) Then

						TTXOrigin = "Origin=""manual"" "
						TTXMatchPercent = "MatchPercent=""0"" "

						If LockTranslated And transstr.State(pslStateTranslated) And Not transstr.State(pslStateReview) Then TTXOrigin = "Origin=""xtranslate"" "
						If LockForReview And transstr.State(pslStateReview) Then TTXOrigin = "Origin=""xtranslate"" "
						If transstr.State(pslStateLocked) Or transstr.State(pslStateReadOnly) Or transstr.Resource.State(pslStateLocked) Or transstr.Resource.State(pslStateReadOnly) Then TTXOrigin = "Origin=""xtranslate"" "

						If transstr.State(pslStateTranslated) And Not transstr.State(pslStateReview) Then TTXMatchPercent = "MatchPercent=""100"" "
						If transstr.State(pslStateReview) Then TTXMatchPercent = "MatchPercent=""75"" "

						If transstr.State(pslStateTranslated) Or SegmentUntranslated Then
	                    	TTXfile.Writeline ("<ut Type=""undefined"" Style=""external"" RightEdge=""angle"" DisplayText="" "">" & translst.ListID & "_" & transstr.Resource.Number & "_" & transstr.Number & "</ut><Tu " + TTXOrigin + TTXMatchPercent + ">" & _
    	                	"<Tuv Lang=""" + source_language + """>" + EscapeWhitespace(XMLify(transstr.SourceText)) + "</Tuv>" & _
        	            	"<Tuv Lang=""" + target_language + """>" + EscapeWhitespace(XMLify(transstr.Text)) + "</Tuv>" & _
            	        	"</Tu><ut Type=""undefined"" Style=""external"" LeftEdge=""angle"" DisplayText="" "">" & translst.ListID & "_" & transstr.Resource.Number & "_" & transstr.Number & "</ut>")
            	        Else
							TTXfile.Writeline ("<ut Type=""undefined"" Style=""external"" RightEdge=""angle"" DisplayText="" "">" & translst.ListID & "_" & transstr.Resource.Number & "_" & transstr.Number & "</ut>" & _
    	                	EscapeWhitespace(XMLify(transstr.SourceText)) & "<ut Type=""undefined"" Style=""external"" LeftEdge=""angle"" DisplayText="" "">" & translst.ListID & "_" & transstr.Resource.Number & "_" & transstr.Number & "</ut>")
						End If

					End If

				End If

			Next j


			nextstringlist:
			If Err.Description <>"" Then
				PSL.Output("Skipping " & translst.Title & ": " & Err.Description)
				Err.Clear
			End If
		Else
			PSL.Output("Skipping " & translst.Title & ": the language does not match")
		End If
	Next i

	TTXfile.Writeline (TTX_Footer)

End Sub

Private Sub ImportTTXFile()

	Dim fso As Object
	Dim TTXfile As Object
	Dim TTXRecord, IDString, SourceText, TargetText As String
	Dim TranslatedCount, AllCount As Long
	Dim TranslistID, TransresourceNumber, TransstrNumber As Long

	Set fso = CreateObject("Scripting.FileSystemObject")

	source_language =LCase(PSL.GetLangCode(myBundle.TransLists(1).SourceList.LangID,pslCodeTrados))


	PSL.Output ("Reading TTX data...")

	'Open the file for writing

	Set TTXfile = fso.OpenTextFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".TTX", ForReading, False, -1)

	TTXRecord = TTXfile.Readline


	For i = 1 To myBundle.TransLists.Count
		Set translst = myBundle.TransLists(i)

		If LCase(PSL.GetLangCode(translst.Language.LangID,pslCodeTrados))=target_language Then
			source_language =LCase(PSL.GetLangCode(translst.SourceList.LangID,pslCodeTrados))

			PSL.Output ("Updating "+ CStr(i) + "/" + CStr(myBundle.TransLists.Count) + " - " + translst.Title)

				AllCount = 0
				TranslatedCount=0
			On Error GoTo nextStringList
			For j = 1 To translst.StringCount
				Set transstr = translst.String(j)

				If Not transstr.State(pslStateHidden) And Not transstr.State(pslStateInvisible) And Not transstr.Resource.State(pslStateHidden) And Not transstr.Resource.State(pslStateInvisible) Then


					If ExportLocked Or Not (transstr.State(pslStateLocked) Or transstr.State(pslStateReadOnly) Or transstr.Resource.State(pslStateLocked) Or transstr.Resource.State(pslStateReadOnly)) Then

						TTXRecord = TTXfile.Readline

						If transstr.State(pslStateTranslated) And Not transstr.State(pslStateReview) Then

						Else
							AllCount = AllCount+1
							' Parse the TTX record
							IDString = Mid(TTXRecord,InStr(TTXRecord,">")+1,InStr(TTXRecord,"</ut>")-InStr(TTXRecord,">")-1)

							TranslistID = CLng(Left(IDString,InStr(IDString,"_")-1))
							IDString = Mid(IDString,Len(TranslistID)+2)
							TransresourceNumber =CLng(Left(IDString,InStr(IDString,"_")-1))
							IDString = Mid(IDString,Len(TransresourceNumber)+2)
							TransstrNumber = CLng(IDString)
							'Delete the first UT tag
							TTXRecord = Mid(TTXRecord,InStr(TTXRecord,"</ut>")+5)
							' Delete the TU tag
							TTXRecord = Mid(TTXRecord,InStr(TTXRecord,">")+1)
							' Delete the first opening TUV tag
							TTXRecord = Mid(TTXRecord,InStr(TTXRecord,">")+1)
							SourceText = Left(TTXRecord,InStr(TTXRecord,"<Tuv ")-1)
							TTXRecord = Mid(TTXRecord,Len(SourceText)+1)
							SourceText = Replace(SourceText,"</Tuv>","")
							SourceText=deXMLify(UnEscapeWhitespace(SourceText))
							' Delete the second opening TUV tag
							TTXRecord = Mid(TTXRecord,InStr(TTXRecord,">")+1)
							TargetText = Left(TTXRecord,InStr(TTXRecord,"</Tu>")-1)
							TargetText = Replace(TargetText,"</Tuv>","")
							TargetText=deXMLify(UnEscapeWhitespace(TargetText))
							If TranslistID =translst.ListID And TransresourceNumber=transstr.Resource.Number And TransstrNumber = transstr.Number And SourceText=transstr.SourceText Then
								TranslatedCount = TranslatedCount+1
								transstr.Text=TargetText
								transstr.State(pslStateTranslated)= True
								transstr.State(pslStateReview)=True
							End If

						End If
					End If

				End If


			Next j
				translst.Save

				PSL.Output("Translated " & CStr(TranslatedCount) & " of " & CStr(AllCount) & " strings")

			nextstringlist:
			If Err.Description <>"" Then
				PSL.Output("Skipping " & translst.Title & ": " & Err.Description)
				Err.Clear
			End If
		Else
			PSL.Output("Skipping " & translst.Title & ": the language does not match")
		End If
	Next i




End Sub



Sub Main

	Dim Bundle As PslProject
	Dim TargetLanguageList() As String
	Dim knownLang As Boolean

	ReDim TargetLanguageList(0)

	PSL.OutputWnd.Clear
	PSL.Output("Scanning open bundles for target languages...")

	For Each Bundle In PSL.Projects
		For Each translst In Bundle.TransLists
			target_language = LCase(PSL.GetLangCode(translst.Language.LangID,pslCodeTrados))
			knownLang=False
			For i=0 To UBound(TargetLanguageList)

				If TargetLanguageList(i) = target_language Then knownLang=True
			Next
			If Not knownLang Then
				If TargetLanguageList(UBound(TargetLanguageList))<>"" Then ReDim Preserve TargetLanguageList(UBound(TargetLanguageList)+1)
				TargetLanguageList(UBound(TargetLanguageList))=target_language
			End If
		Next
	Next



	Begin Dialog UserDialog 690,392,"Export and import TTX" ' %GRID:10,7,1,1
		GroupBox 10,7,670,56,"Scope",.grpScope
		GroupBox 10,63,670,294,"Operation",.grpOperation
		PushButton 420,364,130,21,"Start",.cmdOK
		CancelButton 570,364,100,21,.cmdCancel
		Text 10,371,90,14,"v.1.0",.lblMacroVersion
		Text 60,315,610,28,"Import reads the TTX file <Path_of_Passolo_Bundle>\<Name_of_Passolo_Bundle>_<lang>.ttx Validated strings are not updated.",.lblInstruction
		Text 70,91,450,28,"Export creates the following TTX file: <Path_of_Passolo_Bundle>\<Name_of_Passolo_Bundle>_<lang>.ttx",.lblInstruction2
		GroupBox 50,119,620,175,"Status Filter",.grpStatus
		CheckBox 60,231,400,14,"Lock Translated strings",.LockTranslated
		CheckBox 60,259,400,14,"Export Locked strings",.ExportLocked
		CheckBox 60,189,400,14,"Lock ForReview strings",.LockForReview
		CheckBox 60,140,400,14,"Presegment untranslated strings",.SegmentUntranslated
		Text 100,154,490,14,"Untranslated strings can be presegmented for use in non-Trados environment.",.lblSegmentUntranslated
		Text 100,245,550,14,"Translated and validated strings can be exported as XTranslated to provide context for new translations.",.lblLockTranslated
		Text 100,273,550,14,"Locked strings can be exported as XTranslated to provide context for new translations.",.lblExportLocked
		Text 100,203,540,28,"Auto-translated and For Review strings are exported as XTranslated to provide context for new translations.",.lblExportForReview
		OptionGroup .ExportImport
			OptionButton 30,77,190,14,"Export for translation",.optExport
			OptionButton 20,301,190,14,"Import translations",.optImport
		OptionGroup .ScopeOption
			OptionButton 30,21,200,14,"Process the active bundle",.optActiveBundle
			OptionButton 30,42,220,14,"Process all opened bundles",.optAllOpenedBundles
		Text 310,21,180,14,"Target language to extract:",.lblLanguage
		DropListBox 510,21,90,70,TargetLanguageList(),.lstLanguage,1
	End Dialog

	Dim dlg As UserDialog

	dlg.lstLanguage=TargetLanguageList(0)
	If PSL.Projects.Count=1 Then dlg.ScopeOption=0
	If PSL.Projects.Count>1 Then dlg.ScopeOption=1
	dlg.ExportImport=0
	dlg.LockTranslated=True
	dlg.LockForReview=True
	dlg.SegmentUntranslated=True
	dlg.ExportLocked=False

	If Dialog(dlg) = 0 Then
		Exit Sub
	Else

		target_language = dlg.lstLanguage
		LockTranslated=dlg.LockTranslated
		LockForReview=dlg.LockForReview
		SegmentUntranslated=dlg.SegmentUntranslated
		ExportLocked=dlg.ExportLocked
		If	dlg.ScopeOption =0 Then
			Set myBundle = PSL.ActiveProject
			If dlg.exportimport=0 Then
				ExportTTXFile
			Else
				ImportTTXFile
			End If
		Else
			For Each Bundle In PSL.Projects
				Set myBundle = Bundle
				PSL.Output("Processing " & myBundle.Name)
				If dlg.exportimport=0 Then
					ExportTTXFile
				Else
					ImportTTXFile
				End If
			Next
		End If
	End If

	Done:
	PSL.Output ("--- Done ---")

End Sub


