'#Reference {F5078F18-C551-11D3-89B9-0000F81FE221}#6.0#0#C:\WINDOWS\system32\msxml6.dll#Microsoft XML, v6.0
''Export files to TMX document for using as reference in a TM system
' -------------------------------
' Version 1.0 Laszlo Kovacs 13 April August 2009.
' -------------------------------
' -------------------------------
' Macro executes on:
' Projects		Active translation bundle.
' Source lists	N/A
' Target lists	ALL
' ===============================


Option Explicit

Dim translst As PslTransList
Dim translsts As PslTransLists
Dim transstr As PslTransString
Dim i, j As Long
Dim myBundle As PslProject
Dim ExportTranslated As Boolean
Dim ExportForReview As Boolean
Dim ExportTXT As Boolean
Dim RemoveHotkey As Boolean
Dim RemoveLeadingWS As Boolean
Dim RemoveTrailingWS As Boolean
Dim RemoveEllipsis As Boolean
Dim RemoveHyphen As Boolean
Dim RemoveLineBreaks As Boolean
Dim RemoveTabs As Boolean

Dim source_language As String
Dim target_language As String

Const ForWriting = 2

Private Function ProcessString(PassoloString As String) As String
Dim StringTouched As Boolean
Dim Comparestring As String

	StringTouched=True

	While StringTouched
		Comparestring=PassoloString
		StringTouched=False
		If RemoveHotkey Then
			PassoloString = Replace(PassoloString,"&amp;","")
			PassoloString = Replace(PassoloString,"&","")
		End If

		If RemoveLeadingWS Then
			PassoloString = LTrim(PassoloString)
		End If

		If RemoveTrailingWS Then
			PassoloString = RTrim(PassoloString)
		End If

		If RemoveEllipsis Then
			PassoloString = Replace(PassoloString,"...","")
			PassoloString = Replace(PassoloString,"","")
		End If

		If RemoveHyphen Then
			PassoloString = Replace(PassoloString,"-" & Chr(13),"")
			PassoloString = Replace(PassoloString,"- " & Chr(13),"")
			PassoloString = Replace(PassoloString,"-" & Chr(10),"")
			PassoloString = Replace(PassoloString,"- " & Chr(10),"")
		End If

		If RemoveLineBreaks Then
			PassoloString = Replace(PassoloString,Chr(13)," ")
			PassoloString = Replace(PassoloString,Chr(10)," ")
		End If

		If RemoveTabs Then
			PassoloString = Replace(PassoloString,Chr(9)," ")
		End If
		If Comparestring <> PassoloString Then StringTouched=True

	Wend

ProcessString=PassoloString

End Function

Private Sub ExportTMXFile()

	Dim fso As Object

	Dim TMXDoc As DOMDocument
	Dim TMXElem As IXMLDOMElement
	Dim TMXBody As IXMLDOMElement
	Dim newTUNode, newTUVNode As IXMLDOMElement
	Dim newSourceString As IXMLDOMElement
	Dim newTargetString As IXMLDOMElement
	Dim newNoteString As IXMLDOMElement
	Dim rdr As New SAXXMLReader
	Dim wrt As New MXXMLWriter
	Dim TMXfile, TXTFile As Object
	Dim FileStringCount,TransLstCount As Integer



	Set fso = CreateObject("Scripting.FileSystemObject")

	If ExportTXT Then
		Set TXTFile = fso.OpenTextFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".tmp" , ForWriting, True, -1)
		TXTFile.WriteLine (LCase(PSL.GetLangCode(myBundle.TransLists(1).SourceList.LangID,pslCodeTrados)) & Chr(9) & target_language & Chr(9) & "ID" & Chr(9) & "File name")
	End If

	' Create the TMX object

	Set TMXDoc=CreateObject("Msxml2.DOMDocument")

	TMXDoc.async=False
	TMXDoc.preserveWhiteSpace=True



	PSL.Output ("Preparing TMX data...")


	' Create the root node.

	Set TMXElem = TMXDoc.createNode(1,"tmx","")
	TMXElem.setAttribute("version","1.4")
	TMXDoc.documentElement = TMXElem
	Set TMXBody = TMXDoc.createNode(1,"body","")

	TMXElem.appendChild(TMXBody)

	TransLstCount=0


	For i = 1 To myBundle.TransLists.Count
		Set translst = myBundle.TransLists(i)

		If LCase(PSL.GetLangCode(translst.Language.LangID,pslCodeTrados))=target_language Then



			TransLstCount=TransLstCount+1
			source_language =LCase(PSL.GetLangCode(translst.SourceList.LangID,pslCodeTrados))

			PSL.Output ("Processing "+ CStr(i) + "/" + CStr(myBundle.TransLists.Count) + " - " + translst.Title)


			FileStringCount=0


			On Error GoTo nextStringList
			For j = 1 To translst.StringCount
				Set transstr = translst.String(j)

				If ExportTranslated And transstr.State(pslStateTranslated) Then
					FileStringCount=FileStringCount+1
					Set newTUNode = TMXDoc.createNode(1,"tu","")
					TMXBody.appendChild(newTUNode)

					Set newTUVNode = TMXDoc.createNode(1,"tuv","")
					newTUVNode.setAttribute("xml:lang",source_language)
					newTUNode.appendChild(newTUVNode)

					Set newSourceString = TMXDoc.createNode(1,"seg","")
					newSourceString.Text= ProcessString(transstr.SourceText)
					newTUVNode.appendChild(newSourceString)

					Set newTUVNode = TMXDoc.createNode(1,"tuv","")
					newTUVNode.setAttribute("xml:lang",target_language)
					newTUNode.appendChild(newTUVNode)

					Set newTargetString = TMXDoc.createNode(1,"seg","")
					newTargetString.Text= ProcessString(transstr.Text)
					newTUVNode.appendChild(newTargetString)

					Set newNoteString = TMXDoc.createNode(1,"note","")
					newNoteString.Text= translst.Title + " - " + transstr.Description + Chr(13) + "Passolo Comment: " + transstr.Comment
					newTUVNode.appendChild(newNoteString)

					If ExportTXT Then TXTFile.Writeline (ProcessString(transstr.SourceText) & Chr(9) & ProcessString(transstr.Text) & Chr(9) & transstr.ID & Chr(9) & translst.Title)

				ElseIf ExportForReview And transstr.State(pslStateReview) Then
					FileStringCount=FileStringCount+1
					Set newTUNode = TMXDoc.createNode(1,"tu","")
					TMXBody.appendChild(newTUNode)

					Set newTUVNode = TMXDoc.createNode(1,"tuv","")
					newTUVNode.setAttribute("xml:lang",source_language)
					newTUNode.appendChild(newTUVNode)

					Set newSourceString = TMXDoc.createNode(1,"seg","")
					newSourceString.Text= ProcessString(transstr.SourceText)
					newTUVNode.appendChild(newSourceString)

					Set newTUVNode = TMXDoc.createNode(1,"tuv","")
					newTUVNode.setAttribute("xml:lang",target_language)
					newTUNode.appendChild(newTUVNode)

					Set newTargetString = TMXDoc.createNode(1,"seg","")
					newTargetString.Text= ProcessString(transstr.Text)
					newTUVNode.appendChild(newTargetString)

					Set newNoteString = TMXDoc.createNode(1,"note","")
					newNoteString.Text= translst.Title + " - " + transstr.Description + Chr(13) + "Passolo Comment: " + transstr.Comment
					newTUVNode.appendChild(newNoteString)

					If ExportTXT Then TXTFile.Writeline (ProcessString(transstr.SourceText) & Chr(9) & ProcessString(transstr.Text) & Chr(9) & transstr.ID & Chr(9) & translst.Title)

				End If

			Next j



			nextstringlist:
			If Err.Description <>"" Then
				PSL.Output("Skipping " & translst.Title & ": " & Err.Description)
				Err.Clear
			End If
		Else
			PSL.Output("Skipping " & translst.Title & ": the language does not match")
		End If
	Next i


	wrt.byteOrderMark = False
	wrt.omitXMLDeclaration = False
	wrt.indent = True
	wrt.standalone=True
	wrt.encoding="UTF-8"


	'Set the XML writer to the SAX content handler.
	Set rdr.contentHandler = wrt
	Set rdr.dtdHandler = wrt
	Set rdr.errorHandler = wrt
	rdr.putProperty "http://xml.org/sax/properties/lexical-handler", wrt
	rdr.putProperty "http://xml.org/sax/properties/declaration-handler", wrt
	'Parse the DOMDocument object.
	On Error Resume Next
	rdr.parse TMXDoc

	If Err.Description <>"" Then PSL.Output("Error in XML content, TMX file is incomplete: " & Err.Description)



	'Open the file for writing
	If TransLstCount>0 Then
		Set TMXfile = fso.OpenTextFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".tmx" , ForWriting, True, -1)
		TMXfile.Write (wrt.Output)
		TMXfile.Close
		If ExportTXT Then
			TXTFile.Close
			If fso.FileExists(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".xls") Then fso.DeleteFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".xls")
			fso.MoveFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".tmp",myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".xls")
		End If
	Else
		TXTFile.Close
		If fso.FileExists(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".tmp") Then fso.DeleteFile(myBundle.Location & "\" & myBundle.Name & "_" & target_language & ".tmp")
	End If

End Sub

Sub Main

	Dim Bundle As PslProject
	Dim TargetLanguageList() As String
	Dim knownLang As Boolean

	ReDim TargetLanguageList(0)

	PSL.OutputWnd.Clear
	PSL.Output("Scanning open bundles for target languages...")

	For Each Bundle In PSL.Projects
		For Each translst In Bundle.TransLists
			target_language = LCase(PSL.GetLangCode(translst.Language.LangID,pslCodeTrados))
			knownLang=False
			For i=0 To UBound(TargetLanguageList)

				If TargetLanguageList(i) = target_language Then knownLang=True
			Next
			If Not knownLang Then
				If TargetLanguageList(UBound(TargetLanguageList))<>"" Then ReDim Preserve TargetLanguageList(UBound(TargetLanguageList)+1)
				TargetLanguageList(UBound(TargetLanguageList))=target_language
			End If
		Next
	Next



	Begin Dialog UserDialog 690,294,"Export TMX" ' %GRID:10,7,1,1
		GroupBox 10,7,670,105,"Scope",.grpScope
		GroupBox 10,168,670,84,"String processing",.grpOperation
		PushButton 420,266,130,21,"Start",.cmdOK
		CancelButton 570,266,100,21,.cmdCancel
		Text 10,273,90,14,"v.1.0",.lblMacroVersion
		Text 70,56,450,28,"Export creates the following TMX file: <Path_of_Passolo_Bundle>\<Name_of_Passolo_Bundle>_<lang>.tmx",.lblInstruction2
		GroupBox 10,119,670,42,"Filtering",.grpStatus
		CheckBox 360,140,300,14,"Export Translated strings",.ExportTranslated
		CheckBox 30,140,200,14,"Export ForReview strings",.ExportForReview
		OptionGroup .ScopeOption
			OptionButton 30,21,200,14,"Process the active bundle",.optActiveBundle
			OptionButton 30,42,220,14,"Process all opened bundles",.optAllOpenedBundles
		Text 310,21,180,14,"Target language to extract:",.lblLanguage
		DropListBox 510,21,90,70,TargetLanguageList(),.lstLanguage,1
		CheckBox 30,189,140,14,"Remove hotkeys",.RemoveHotkey
		CheckBox 220,189,210,14,"Remove leading whitspaces",.RemoveLeadingWS
		CheckBox 220,210,210,14,"Remove trailing whitspaces",.RemoveTrailingWS
		CheckBox 30,210,140,14,"Remove ellipsis",.RemoveEllipsis
		CheckBox 30,231,170,14,"Remove hyphenation",.RemoveHyphen
		CheckBox 470,189,170,14,"Remove line breaks",.RemoveLineBreaks
		CheckBox 470,210,170,14,"Remove tabulators",.RemoveTabs
		CheckBox 30,91,640,14,"Create a tab-delimited TXT: <Path_of_Passolo_Bundle>\<Name_of_Passolo_Bundle>_<lang>.xls",.ExportTXT

	End Dialog

	Dim dlg As UserDialog

	dlg.lstLanguage=TargetLanguageList(0)
	If PSL.Projects.Count=1 Then dlg.ScopeOption=0
	If PSL.Projects.Count>1 Then dlg.ScopeOption=1
	dlg.ExportTXT=True
	dlg.ExportTranslated=True
	dlg.ExportForReview=True
	dlg.RemoveHotkey=True
	dlg.RemoveLeadingWS=True
	dlg.RemoveTrailingWS=True
	dlg.RemoveEllipsis=True
	dlg.RemoveHyphen=True
	dlg.RemoveLineBreaks=True
	dlg.RemoveTabs=True


	If Dialog(dlg) = 0 Then
		Exit Sub
	Else

		target_language = dlg.lstLanguage
		ExportTranslated=dlg.ExportTranslated
		ExportForReview=dlg.ExportForReview
		ExportTXT=dlg.ExportTXT

		RemoveHotkey=dlg.RemoveHotkey
		RemoveLeadingWS=dlg.RemoveLeadingWS
		RemoveTrailingWS=dlg.RemoveTrailingWS
		RemoveEllipsis=dlg.RemoveEllipsis
		RemoveHyphen=dlg.RemoveHyphen
		RemoveLineBreaks=dlg.RemoveLineBreaks
		RemoveTabs=dlg.RemoveTabs

		If ExportTXT And Not (RemoveLineBreaks And RemoveTabs) Then
			MsgBox("Line breaks and tabs should be removed to enable TXT output." & Chr(13) & "Remove line breaks and Remove tabulators will be enabled")
			RemoveLineBreaks=True
			RemoveTabs=True

		End If

		If	dlg.ScopeOption =0 Then
			Set myBundle = PSL.ActiveProject
			ExportTMXFile
		Else
			For Each Bundle In PSL.Projects
				Set myBundle = Bundle
				PSL.Output("Processing " & myBundle.Name)
				ExportTMXFile
			Next
		End If
	End If

	Done:
	PSL.Output ("--- Done ---")

End Sub


